#include <f1ll/ringbuffer.h>

#include <iostream>

using namespace std;

int main()
{
    uint8_t rb_buffer[8];
    uint8_t dst_buffer[sizeof(rb_buffer) - 1];
    uint8_t data1[4] = {0, 1, 2, 3};
    uint8_t data2[4] = {4, 5, 6, 7};

    f1ll::ringbuffer rb(rb_buffer, sizeof(rb_buffer));

    int16_t added = rb.put(data1, sizeof(data1));
    cout << "Added " << added << " bytes to the buffer. It reports " << rb.uncommited() << " uncommited and " << rb.commited()
         << " commited bytes." << endl;
    rb.commit();
    cout << "After commit, there are " << rb.commited() << " commited and " << rb.uncommited() << " uncommited bytes in the buffer" << endl;
    added = rb.put(data1, sizeof(data1));
    cout << "Added " << added << " bytes to the buffer. It reports " << rb.uncommited() << " uncommited and " << rb.commited()
         << " commited bytes." << endl;
    rb.commit();
    cout << "After commit, there are " << rb.commited() << " commited and " << rb.uncommited() << " uncommited bytes in the buffer" << endl;
}
